#include "testlib.h"
#include <vector>

using namespace std;

int n, m;
vector<string> f;

int readAnswer(InStream &in) {
    int a = in.readInt(1, n);
    int b = in.readInt(1, m);
    if (n % a != 0 || m % b != 0) {
        in.quitf(_wa, "output size isn't a divisor of input size");
    }
    vector<string> ff(a);
    for (int i = 0; i < a; i++) {
        ff[i] = in.readToken("[.X]+");
        if (ff[i].length() != b) {
            in.quitf(_wa, "line %d: bad row size", i);
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (f[i][j] != ff[i / (n / a)][j / (m / b)]) {
                in.quitf(_wa, "incorrect compression in cell (%d, %d)", i, j);
            }
        }
    }
    return a * b;
}

int main(int argc, char *argv[]) {
    registerTestlibCmd(argc, argv);

    n = inf.readInt();
    m = inf.readInt();
    f.resize(n);
    for (int i = 0; i < n; i++) {
        f[i] = inf.readToken();
    }

    int pa = readAnswer(ouf);
    int ja = readAnswer(ans);

    if (pa == ja) {
        quitf(_ok, "%d", pa);
    } else if (pa > ja) {
        quitf(_wa, "jury has better answer");
    } else {
        quitf(_fail, "participant has better asnwer");
    }
}
