#include <bits/stdc++.h>

int MAX = (int)1e9;

int dfs(std::map<std::string, std::vector<std::string>> &graph,
              std::map<std::string, int> &dp,
              std::string &v) {
  if (graph[v].size() == 0) {
    return dp.find(v) == dp.end() ? MAX : dp[v];
  }
  int sum = 0;
  for (auto &u : graph[v]) {
    int uv = dfs(graph, dp, u);
    sum = std::min(MAX, sum + uv);
  }
  if (dp.find(v) != dp.end()) {
    dp[v] = std::min(dp[v], sum);
  } else {
    dp[v] = sum;
  }
  return dp[v];
}

int main() {
  int n;
  std::cin >> n;
  std::vector<std::string> ingredients(n);
  for (int i = 0; i < n; i++) {
    std::cin >> ingredients[i];
  }
  std::map<std::string, int> dp;
  int m;
  std::cin >> m;
  for (int i = 0; i < m; i++) {
    std::string s;
    int cost;
    std::cin >> s >> cost;
    dp[s] = cost;
  }
  int k;
  std::cin >> k;
  std::map<std::string, std::vector<std::string>> graph;
  for (int i = 0; i < k; i++) {
    int c;
    std::cin >> c;
    std::string ing;
    std::cin >> ing;
    for (int j = 0; j < c; j++) {
      std::string s;
      std::cin >> s;
      graph[ing].push_back(s);
    }
  }
  for (const auto &v : graph) {
    std::string s = v.first;
    dfs(graph, dp, s);
  }
  int answer = 0;
  for (auto ing : ingredients) {
    answer = std::min(MAX, answer + dp[ing]);
  }
  printf("%d\n", answer == MAX ? -1 : answer);
  return 0;
}
