#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <unordered_map>

using namespace std;

#define TASK ""
typedef long long ll;
const int INF = (int)1e9 + 23;
const ll LINF = (ll)1e18 + 23;

int solve();

int main() {
	ios_base::sync_with_stdio(0);
#ifdef home
	freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);
#else 
	cin.tie(0);
	cout.tie(0);
	if (TASK != "") freopen(TASK".in", "r", stdin), freopen(TASK".out", "w", stdout);
#endif
	solve();
	return 0;
}
const int dd = 1e3 + 3;
int c[dd], used[dd];

vector<vector<pair<int, int>>> g;

unordered_set<int> ind;
void color(int v, int col) {
	c[v] = col, used[v] = 1;
	if (c[v] == 1) ind.insert(v);

	for (auto p : g[v]) {
		int u = p.first, t = p.second;
		if (used[u] && (col^t) != c[u]) cout << "No", exit(0);
		if (!used[u]) color(u, col^t);
	}
}

int solve() {
	int n, m; cin >> n >> m;

	vector<vector<int>> a(n);
	for (int i = 0; i < n; i++) {
		a[i].resize(m);
		for (int j = 0; j < m; j++) {
			cin >> a[i][j];
		}
	}

	for (int j = 0; j < m; j++) {
		unordered_multiset<int> was;
		for (int i = 0; i < n; i++) {
			was.insert(a[i][j]);
			was.insert(a[i][m - j - 1]);

			if (was.count(a[i][j]) > 2 || was.count(a[i][m - j - 1]) > 2) cout << "No", exit(0);
		}
	}

	g.resize(n);
	for (int j = 0; j <= m / 2; j++) {

		unordered_map<int, pair<int, int>> prev;
		for (int i = 0; i < n; i++) {
			for (int it = 0; it < 2; it++) {
				if (prev.find(a[i][j]) != prev.end()) {
					int v = prev[a[i][j]].first, old_j = prev[a[i][j]].second;
					g[i].push_back({v, old_j == j}), g[v].push_back({i, old_j == j});
				}
				j = m - j - 1;
			}
			prev[a[i][j]] = {i, j}, prev[a[i][m - j - 1]] = {i, m - j - 1};
		}
	}

	for (int i = 0; i < n; i++) {
		if (!used[i]) color(i, 0);
	}

	cout << "Yes" << endl << ind.size() << endl;
	for (int x : ind) cout << x + 1 << ' ';
	return 0;
}