#include <iostream>
#include <stdio.h>
#include <cmath>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <stack>
#include <string>
#include <bitset>
#include <ctime>
#pragma comment(linker, "/STACK:256000000")
using namespace std;

#define in(s) freopen(s, "r", stdin)
#define out(s) freopen(s, "w", stdout)
#define forn(i, n) for (int i = 0; i < n; i++)
#define endl '\n'
#define mp make_pair

typedef long long ll;
typedef long double ld;

struct vec
{
	ll x, y;

	vec()
	{
		this->x = 0ll;
		this->y = 0ll;
	}

	vec(ll nx, ll ny)
	{
		this->x = nx;
		this->y = ny;
	}

	vec operator+(const vec &b) const
	{
		return vec(x + b.x, y + b.y);
	}
	vec operator-(const vec &b) const
	{
		return vec(x - b.x, y - b.y);
	}
	ll operator%(const vec &b) const
	{
		return x * b.y - y * b.x;
	}
	ll operator*(const vec &b) const
	{
		return x * b.x + y * b.y;
	}
	ll len()
	{
		return x * x + y * y;
	}
};

bool cmp1(pair<vec, int> a, pair<vec, int> b)
{
	if (a.first.x != b.first.x)
		return a.first.x < b.first.x;
	else
	{
		if (a.first.y != b.first.y)
			return a.first.y < b.first.y;
		else
			return a.second < b.second;
	}
}

bool cmp2(pair<vec, int> a, pair<vec, int> b)
{
	if (a.first % b.first == 0ll)
		return a.first.len() < b.first.len();
	else
		return a.first % b.first > 0ll;
}

void solve(vector <vec> have)
{
	int n = (int)have.size();
	vector < pair<vec, int> > arr(n);
	forn(i, n)
		arr[i] = mp(have[i], i);

	sort(arr.begin(), arr.end(), cmp1);
	vec start = arr[0].first;

	forn(i, n)
		arr[i].first = arr[i].first - start;

	sort(arr.begin(), arr.end(), cmp2);

	vector < pair<vec, int> > q;
	forn(i, n)
	{
		if ((int)q.size() < 2)
		{
			q.push_back(arr[i]);
			continue;
		}
		while ((int)q.size() > 1)
		{
			vec a = q[(int)q.size() - 2].first - q.back().first;
			vec b = arr[i].first - q.back().first;

			if (a % b < 0ll)
				break;
			q.pop_back();
		}
		q.push_back(arr[i]);
	}

	vector <bool> used(n);
	forn(i, (int)q.size())
		used[q[i].second] = true;

	forn(i, n)
	{
		if (!used[i])
		{
			cout << "1\n" << i + 1;
			exit(0);
		}
	}

	cout << "2\n";
	cout << q[0].second + 1 << " " << q[2].second + 1;
	
	return;
}

int main()
{
	//in("input.txt");
	//out("output.txt");
	srand(1373737);
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	int n;
	cin >> n;

	set < pair<ll, ll> > ss;
	vector <vec> arr(n);

	forn(i, n)
	{
		cin >> arr[i].x >> arr[i].y;
		if (ss.count(mp(arr[i].x, arr[i].y)))
		{
			cout << "1\n" << i + 1;
			return 0;
		}
		ss.insert(mp(arr[i].x, arr[i].y));
	}

	solve(arr);

	return 0;
}